import type WebSocket from 'ws';
import type { BrowserSocket } from './bidi/socket.js';
import type { FetchRequest } from './request/web.js';
/**
 * @internal
 */
export declare const isNode: boolean;
export interface EnvironmentVariables {
    WEBDRIVER_CACHE_DIR?: string;
    PROXY_URL?: string;
    NO_PROXY?: string[];
}
export interface EnvironmentDependencies {
    Request: typeof FetchRequest;
    Socket: typeof BrowserSocket;
    createBidiConnection: (wsUrl?: string, options?: WebSocket.ClientOptions) => Promise<WebSocket | undefined>;
    variables: EnvironmentVariables;
}
/**
 * Holder for environment dependencies. These dependencies cannot
 * be used during the module instantiation.
 */
export declare const environment: {
    value: EnvironmentDependencies;
};
//# sourceMappingURL=environment.d.ts.map